#include "UWater_frame_app.h"
#include "UWater_eeprom_driver.h"
#include "UWater_rtcc_app.h"
#include "UWater_power_app.h"
#include "UWater_rtcc_driver.h"
#include "UWater_gp22_app.h"
#include "UWater_Nb_SS_DataManage.h"
#include "UWater_DataTools_App.h"
#include "UWater_key_app.h"
#include "UWater_pt_app.h"
#include "UWater_DebugPrint.h"
#include "UWater_ir_app.h"
#include "UWater_Valve_app.h"
#include <string.h>
#include "nb_uart_driver_bc25.h"	
#include "nb_driver_bc25.h"
#include "UWater_JX_Store_App.h"

STRU_UPLOAD_FRAME upload_frame; //coapϱ֡
//ȡϱźֵ,صѹ
static void UploadGetInfo(void)
{
	s16 s_temp_data=0;
	
	NbiotGetSNR(&s_temp_data);
	if(s_temp_data<0)
	{
	    upload_frame.data.UploadInfo.metinfo.snr_val =(-s_temp_data);
		upload_frame.data.UploadInfo.metinfo.snr_val |= 0x8000;
	}
	else
	{
	    upload_frame.data.UploadInfo.metinfo.snr_val = s_temp_data;
	}
	//
	NbiotGetECL(&s_temp_data);
	if(s_temp_data<0)
	{
		upload_frame.data.UploadInfo.metinfo.ecl_val |= (-s_temp_data)&0x8000;
	}
	else
	{
	    upload_frame.data.UploadInfo.metinfo.ecl_val = s_temp_data;
	}
	//
	NbiotGetRSRP(&s_temp_data);
	upload_frame.data.UploadInfo.metinfo.RSRP_val = -s_temp_data;
	NbiotGetCSQ(&upload_frame.data.UploadInfo.metinfo.single_val); 
	upload_frame.data.UploadInfo.metinfo.single_val = (upload_frame.data.UploadInfo.metinfo.single_val / 10)*16 + (upload_frame.data.UploadInfo.metinfo.single_val%10);
	//ȡѹֵ
	upload_frame.data.UploadInfo.metinfo.bat_val.u16_data =HexToBcd16(PowerCheckValueSys());															
	upload_frame.data.UploadInfo.metinfo.bat_threshold_val = 0x03;//Ƿѹֵ3v
}
//ݰеĵǰϢ״̬
void Upload_RenewCurrentData(void)
{
	MET_STATE temp_state; //״̬
	u8 temp1 = 0;

	tmp_float.gp22_u32  = Gp30CheckDataApp(2);
	upload_frame.data.CurrentFlow.datas = (u32)(tmp_float.gp22_float*10);//ǰۼ
	upload_frame.data.CurrentFlowForward.datas = upload_frame.data.CurrentFlow.datas;//ǰۼ
	tmp_float.gp22_u32 = Gp30CheckDataApp(3);//ǰۻ
	upload_frame.data.CurrentFlowReverse.datas = (u32)(tmp_float.gp22_float*10);
	//ȡ:(4ֽ),ʱ(2ֽ),ʼʱ(8ֽ,Ԥ)	
	RtccCheck_Hight_Flow(&hight_flow);			
	for(temp1 = 0; temp1 <14 ;temp1++)
	{
		upload_frame.data.DailyHighestFlowAndTime[temp1] = *(hight_flow+temp1);
	}
	//ȡ:rsrp(2B),صѹ(2B),(2B),źŸǵȼecl(2B),CSQ(1B),ѹֵ(1B)
	UploadGetInfo();//UploadGetReportInfo(upload_frame.data.UploadInfo.byte);
	//ȡ:2B()X2(/h)X24h=96B
	/*
	ϱʱͨUPLOAD_DATA_READ_HISȡ0洢ʱͨUPLOAD_DATA_STEP_FLOWȡ
	*/
	//ϱʱ
	RtccGetDateTime(&Rtcc_time);//ϱʱ
	upload_frame.data.UploadTime[0] = Rtcc_time.s.second;
	upload_frame.data.UploadTime[1] = Rtcc_time.s.minute;
	upload_frame.data.UploadTime[2] = Rtcc_time.s.hour;
	upload_frame.data.UploadTime[3] = Rtcc_time.s.day;
	upload_frame.data.UploadTime[4] = Rtcc_time.s.month;
	upload_frame.data.UploadTime[5] = Rtcc_time.s.year; 
	upload_frame.data.UploadTime[6] = 0x20;
	//ʼʱ	
	upload_frame.data.StepFlowStartTime[0]= 0x00;
	upload_frame.data.StepFlowStartTime[1]= 0x00;
	upload_frame.data.StepFlowStartTime[2]= 0x00;
	upload_frame.data.StepFlowStartTime[3]= g_date_jiange.s.day ;
	upload_frame.data.StepFlowStartTime[4]= g_date_jiange.s.month;
	upload_frame.data.StepFlowStartTime[5]= g_date_jiange.s.year;        
	upload_frame.data.StepFlowStartTime[6]= 0x20; 
	//״̬
	temp_state = FrameGetByte();
	upload_frame.data.StateBytes[0] = temp_state.stat0;
	upload_frame.data.StateBytes[1] = temp_state.stat1;
	upload_frame.data.StateBytes[2] = temp_state.stat2;
	upload_frame.data.StateBytes[3] = temp_state.stat3;
	upload_frame.data.StateBytes[4] = temp_state.stat4;
	//ۼƻԾʱ
	upload_frame.data.DailyActiveTime.datas = g_activity_times;
}







