
/*******************************************************************************
* @Copyright (c)    :(C)2017, Qingdao ieslab Co., Whn
* @FileName         :GP22Gas_lcd_app.c
* @Author           :Team
* @Version          :V1.0
* @Date             :2017825 11:00:39
* @Description      :the function of the entity of GP22Gas_lcd_app.c
*******************************************************************************/

#include "type.h"
#include "UWater_lcd_driver.h"
#include "UWater_lcd_app.h"
#include "UWater_gp22_app.h"
#include "UWater_rtcc_app.h"
#include "UWater_key_app.h"
#include "UWater_power_app.h"
#include "UWater_frame_app.h"
#include "UWater_pt_app.h"
#include "UWater_valve_app.h"
#include "UWater_valve_driver.h"
#include "nb_driver_bc25.h"
#include "sys_processor.h"
#include "UWater_sys.h"

/*------------------------------ Variable Define -------------------------------------*/
//״̬״̬
static u8 s_lcd_status_state; //״ָ̬ʾ״̬
//static u8 s_lcd_rf_state; //״ָ̬ʾ״̬״̬
static u8 s_lcd_time_state; //ʱ״̬״̬
//static u8 s_lcd_ram_state; //RAM״̬״̬
static u8 s_lcd_key_state; //״̬״̬
//static u8 s_lcd_init_state; //ʼ״̬״̬
//static u8 s_lcd_up_state= 0;
//static u8 s_lcd_characters_state=1;//ַָ̻ʾ״̬
//static u8 s_lcd_VAL_state_SET = 1;//
//static u8 s_lcd_VAL_Met_state = 1;//
//static u8 s_lcd_VAL_Ram_state = 1;//
//static u8 s_lcd_VAL_GSM_state = 1;
//static u8 s_lcd_first_power_state;
//˵
static u8 s_fst_num; //һ˵Ĳ˵
static u8 s_sec_num; //˵Ĳ˵

//ʱ״̬
//static u32 s_Lcd_time_old_num = 0;
//static u32 s_Lcd_time_num = 0;


//б
static u8 s_vol_app_state; //¼ϴεصѹ״̬
static u8 s_low_flow_alarm_app_state; //¼ϴγź״̬
static u8 s_alarm_app_state; //¼ϴα״̬
static u8 s_failure_app_state; //¼ϴι״̬
static u8 s_active_RF_app_state; //¼ϴͨ״̬
static u8 s_valve_app_state; //¼ϴη״̬
//static u8 s_lcd_check_gp30_msg;
static u8 s_lcd_check_gp30_app_msg;
//static u8 key_message =0;
//static u8 s_lcd_valve_stat;//״̬
//static u8 s_pay_state=0;// Ԥ״̬

static u8 s_a1_index; //¼Ǽ춨״̬GP30
static u8 s_a2_index; //¼ڶ
static u8 s_a3_index; //¼
static u8 s_a4_index; //¼춨״̬GP30
static u32 s_a1_backup; //¼Ǽ춨״̬µǰLCDʾ
static u32 s_a2_backup; //¼A2ǰLCDʾ
static u32 s_a3_backup; //¼A3ǰLCDʾ
static u32 s_a4_backup; //¼춨״̬µǰLCDʾ
//static u16 s_nb_active_time;//NBԾʱ
/*------------------------------ function declare -------------------------------------*/


//static void LcdSet1sTimer(u32 time5ms_span);
//static u8 LcdCheck1sTimer(void);

static u32 GetA1Data(u8 index);
static u32 GetA2Data(u8 index);
static u32 GetA3Data(u8 index);
static u32 GetA4Data(u8 index);

static void LcdDispayFLoat(float lcd_data, u8 point);
static void LcdDispayU32Data(u32 lcd_data, u8 point);

static void LcdDisplayMenu(u8 num);
static void LcdDisplayA1(u8 num);
static void LcdDisplayA2(u8 num);
static void LcdDisplayA3(u8 num);
static void LcdDisplayA4(u8 num);




/****************************************/

/*************************************************
Function:void KeySet1sTimer(u16 time5ms_span)
Description: 5msʱ
Input:	time5ms_span:ʱ
Return: SUCCESSʼɹERROR ʼʧ
Others:ڲӿ
*************************************************/
//static void LcdSet1sTimer(u32 time1s_span)
//{
//    s_Lcd_time_num = time1s_span * 1000 * 1000;
//    s_Lcd_time_old_num = Timer1usGetTick();
//}
/*************************************************
Function: u8 KeyCheck1sTimer(void)
Description: 鶨ʱǰֵΪ0˵ʱʱ䵽
Input:	void
Return: ʱǰֵ
Others:	ڲӿ
*************************************************/
//static u8 LcdCheck1sTimer(void)
//{
//    u32 tmp_count = 0;

//    tmp_count = Timer1usGetTick() - s_Lcd_time_old_num;

//    if(tmp_count >= s_Lcd_time_num)
//    {
//        return 0;
//    }
//    else
//    {
//        return 1;
//    }
//}
///*************************************************
//Function:void KeySet5msTimer(u16 time5ms_span)
//Description: 5msʱ
//Input:	time5ms_span:ʱ
//Return: SUCCESSʼɹERROR ʼʧ
//Others:ڲӿ
//*************************************************/
//static void LcdSet_first5msTimer(u32 time5ms_span)
//{
//    s_Lcd_first_time_num = time5ms_span * 1000 * 5;
//    s_Lcd_first_time_old_num = Timer1usGetTick();
//}
///*************************************************
//Function: u8 KeyCheck5msTimer(void)
//Description: 鶨ʱǰֵΪ0˵ʱʱ䵽
//Input:	void
//Return: ʱǰֵ
//Others:	ڲӿ
//*************************************************/
//static u8 Lcd_firstCheck5msTimer(void)
//{
//    u32 tmp_count = 0;

//    tmp_count = Timer1usGetTick() - s_Lcd_first_time_old_num;

//    if(tmp_count >= s_Lcd_first_time_num)
//    {
//        return 0;
//    }
//    else
//    {
//        return 1;
//    }
//}
/*************************************************************************************
 * @fun_name   static void LcdUpdateData()
 * @brief      	LCD
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdUpdateData()
{
    if (s_fst_num == A1 && s_sec_num != AB0)
    {
        if (s_a1_backup != GetA1Data(s_a1_index))
        {
            LcdDisplayA1(s_sec_num);
        }
    }
    if (s_fst_num == A2 && s_sec_num != AB0)
    {
        if (s_a2_backup != GetA2Data(s_a2_index))
        {
            LcdDisplayA2(s_sec_num);
        }
    }
    if (s_fst_num == A3 && s_sec_num != AB0)
    {
        if (s_a3_backup != GetA3Data(s_a3_index))
        {
            LcdDisplayA3(s_sec_num);
        }
    }
    if (s_fst_num == A4 && s_sec_num != AB0)
    {
        if (s_a4_backup != GetA4Data(s_a4_index))
        {
            LcdDisplayA4(s_sec_num);
        }
    }
}

/*************************************************************************************
 * @fun_name   static void LcdDispayU32Data(u32 lcd_data, u8 point)
 * @brief      	LCDʾU32
 * @param[in] 	u32 lcd_data, u8 point
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdDispayU32Data(u32 lcd_data, u8 point)
{
    s8 index = 8;
     u8 n;
    if (lcd_data != 0)
    {
        while (lcd_data && index >= 0)
        {
            LcdDisplayData(index--, lcd_data % 10);
            lcd_data /= 10;
					
        }
    }
    else
    {
		n=6-point;
		while(n&&(point!=0))
		{
		    LcdDisplayData(index--,0);
		    n--;
		}
		if(0==point)  // whn  2017-10-12 
		{
		    LcdDisplayData(8,0);
		}
    }
    //ʾС
    switch(point)
    {
		case 0:
		{
			LcdDisplayFun(LcdGetDisplayFun());
			break;
		}
		case 1:
		{
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P1); 
			break;
		}
		case 2:
		{
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P2);
			break;
		}
		case 3:
		{
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P3);
			break;
		}
		case 4:
		{
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P4);
			break;
		}
		default:
		{
		    LcdDisplayFun(LcdGetDisplayFun());
		}
    }
}
///*************************************************************************************
// * @fun_name   static void LcdDispayTimeU32Data(u32 lcd_time_data)
// * @brief      	LCDʾu32
// * @param[in] 	u32 lcd_data, u8 point
// * @param[out] 	None
// * @retval     	None
// * @other     	None
// *************************************************************************************/
//static void LcdDispayTimeU32Data(u32 lcd_time_data)
//{
//    if (lcd_time_data <100)
//    {   
//        if (lcd_time_data == 0)
//        {
//            LcdDisplayData(7, 0);
//            LcdDisplayData(6, 0);
//            LcdDisplayData(5, 0);
//        }
//        else if(s_a1_backup < 10)
//        {
//            LcdDisplayData(6, 0);
//            LcdDisplayData(5, 0);
//            LcdDispayU32Data(s_a1_backup, 0);
//        }
//        else 
//        {
//            LcdDisplayData(5, 0);
//            LcdDispayU32Data(s_a1_backup, 0);
//        }
//    }
//    else
//    {  
//        s8 index = 7;
//        while (lcd_time_data && index >= 0)
//         {
//             LcdDisplayData(index--, lcd_time_data % 10);
//             lcd_time_data /= 10;
//         }
//    }
//}
/*************************************************************************************
 * @fun_name   static void LcdDispayFLoat(float lcd_data, u8 point)
 * @brief      	LCDʾ
 * @param[in] 	float lcd_data, u8 point
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdDispayFLoat(float lcd_data, u8 point)
{
    s8 index = 9;
    u64 udata = 0;
    float temp = lcd_data;
    if (temp < 0)
    {
        temp = -temp;
    }
	switch(point)
    {
		case 0:
		{
			temp=1000000*temp;
			LcdDisplayFun(LcdGetDisplayFun());//ʾС
			break;
		}
		case 1:
		{
			temp=100000*temp;
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P1 |FUN_P1G|FUN_P2G|FUN_P3G|FUN_P4G|FUN_P5G);//ʾP1С  gaishanxiugai
			break;
		}
		case 2:
		{
			temp=10000*temp;
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P2 |FUN_P2G|FUN_P3G|FUN_P4G|FUN_P5G);//ʾP2С
			break;
		}
		case 3:
		{
			temp=1000*temp;
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P3 |FUN_P3G|FUN_P4G|FUN_P5G);//ʾP3С
			break;
		}
		case 4:
		{
			temp=100*temp;
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P4 |FUN_P4G|FUN_P5G); //ʾP4С
			break;
		}
		case 5:
		{
			temp=10*temp;
			LcdDisplayFun(LcdGetDisplayFun() | FUN_P5 |FUN_P5G); //ʾP5С
		  break;
		}
		default:
		{
			temp=temp;
			LcdDisplayFun(LcdGetDisplayFun());//ʾС
		}
    }
    udata = (u64) (temp );
    if (udata != 0)
    {
        while (udata && index >= 0)
        {
            LcdDisplayData(index--, udata % 10);
            udata /= 10;
        }
    }
    else
    {
        LcdDisplayData(9, 0);//gaishanxiugai
    }
    //ʾС
    if (point > 0 && point < 6)
    {
        LcdDisplayFun(LcdGetDisplayFun() | (FUN_REVERSE << point));
        while (index >= (3 + point))//ʾ
        {
            LcdDisplayData(index--, 0);
        }
    }
    //ʾ
    if (index >=0&& (lcd_data < 0))
    {
        LcdDisplayData(index--, DIS_HG);
    }	 
}

/*************************************************************************************
 * @fun_name   static u32 GetA1Data(u8 index)
 * @brief      	LCDA1
 * @param[in] 	index
 * @param[out] 	data
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static u32 GetA1Data(u8 index)
{
    u32 data = 0;
	if (index == 0x55)
	{
		data = RtccGetWorkHourApp(); //ȡۼʱ
	}
	else if(index==GP30_APP_INS_FLOW)
	{
	    data=Gp30CheckDataApp(GP30_APP_INS_FLOW); //ȡ˲ʱ
	}   	
	else if( index == GP30_APP_TOTAL_FLOW)
	{
	    data =Gp30CheckDataApp(GP30_APP_TOTAL_FLOW) ; //ȡۼ
	}
	else if( index == GP30_APP_TOTAL_FLOW_REVERSE)
	{
	    data =Gp30CheckDataApp(GP30_APP_TOTAL_FLOW_REVERSE) ; //ȡۼ
	}
	
    return data;
}

/*************************************************************************************
 * @fun_name   static u32 GetA2Data(u8 index)
 * @brief      	LCDA2
 * @param[in] 	index
 * @param[out] 	data
 * @retval     	None
 * @other     	None
 *************************************************************************************/

static u32 GetA2Data(u8 index)
{
     u32 data = 0;
    if (index == 0x11)
    {
        //ǰ
        static DateTime date;
       if (RtccGetDateTime(&date))//ȷʱ
        {
            data |= ((u32) date.s.year) << 16;
            data |= ((u32) date.s.month) << 8;
            data |= date.s.day;
        }
        else
        {
            data = 0xEEEEEE;//ȡʱ䲻ȷ
        }
    }

    else if (index == 0x22) //ǰʱ
    {

        static DateTime time;
        if (RtccGetDateTime(&time))
        {
            data |= ((u32) time.s.hour) << 16;
            data |= ((u32) time.s.minute) << 8;
            data |= time.s.second;
        }
        else
        {
            data = 0xEEEEEE;
        }
    }
	else if(index==1) //ھ
	{
	    data = FrameCheckParaApp(FramePara_DNx);//2019-11-11Ŀھ FrameCheckParaApp(19)Ϊ FrameCheckParaApp(0),GP30		
	}
	else if(index==2)//汾
	{
	    data = FrameCheckParaApp(FramePara_ProgVersion);
	}
	else if(index==4)
	{
	    data = FrameCheckParaApp(FramePara_MetAddr0_3) ; //ȡƵַ4
	}
	else if(index==3)
	{
	    data = FrameCheckParaApp(FramePara_MetAddr4); //ȡǵַ1
	}
	else if(index==5)//ʾСϵ
	{
	    data = Read_Flow_CofficientApp_For_LCD(6);
	}
	else if(index==6)//ʾ1ϵ
	{
	    data=Read_Flow_CofficientApp_For_LCD(7);
	}
	else if(index==7)//ʾ2ϵ
	{
	    data=Read_Flow_CofficientApp_For_LCD(8);
	}
	else if(index==8)//ʾ3ϵ
	{
	    data=Read_Flow_CofficientApp_For_LCD(9);
	}
	else if(index==9)//ʾϵ
	{
	    data=Read_Flow_CofficientApp_For_LCD(10);
	}
	else if(index==10)//ʾboot汾
	{
	    data=FrameCheckParaApp(FramePara_BootVersion);
	}
	else if(index ==11)//NB״̬Ϣ
	{
		data = sys_get_net_state();
	}
	return data;
}

/*************************************************************************************
 * @fun_name   static u32 GetA3Data(u8 index)
 * @brief      	LCDA3
 * @param[in] 	index
 * @param[out] 	data
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static u32 GetA3Data(u8 index)
{
    u8 data = 0;
    //u8 temp;        
    u8 Lcd_Frame_state;
    //temp = s_lcd_check_gp30_msg;
    Lcd_Frame_state = s_lcd_check_gp30_app_msg;
    if(index == 0x01)
    {
        if (0x08 ==(Lcd_Frame_state & (0x08)))//bit3 ܵˮ data0 1 2 3λΪ1쳣Ϊϻˮ³ޣװܵˮ
        {
              data |= 0x08;
        }   
        else
        {
              data &= ~(0x08);
        }
        if (0x04 ==(Lcd_Frame_state & (0x04)))// bit2 װ
        {
              data |= 0x04;
        }
        else
        {
              data &= ~(0x04);
        }
        if (0x02 == (Lcd_Frame_state & (0x02)))//bit1 ˮ³¶ȵȼΧ
        {
              data |= 0x02;
        }
        else
        {
              data &= ~(0x02);
        }
        if(0x40 == (Lcd_Frame_state & 0x40))//bit6 ϻ
        {
              data|= 0x01;
        }
        else
        {
              data &= (~0x01);
        }

    }
    else if (index == 0x02)//
    { 
//        s_lcd_valve_stat = ValveGetStateApp();
        //if(0x08 ==(temp &(0x08)))//bit3 GP30 data4 5 6 7λΪ2쳣
        if(0x10 ==(Lcd_Frame_state &(0x10)))
		{                       //ֱΪ GP30ϣ¶ȴ·¶ȴ·ͨ쳣
            data |= 0x10;
        }
        else
        {
            data &= ~(0x10);
        }
//        if(0x01==Check_Ip_Set_Message())//IPʧ
//        {
//            data |=0x20;
//        }
//        else
//        {
//            data&=~(0x20);
//        }
        if(NB_SS_Control_GetPara(NB_UploadFailTimes))//ǷҪ
        {                      
            data |= 0x80;//ҪͨŹϱ־
        }
        else
        {
            data &= ~(0x80);//ҪͨŹϱ־
        }
		#if defined(VALVE)//Źϱ־
        if(Sys_data_object.P1.ies_valve_paras.valve_err)
        {
            data |= 0x40;
        }
        else
        {
            data &= ~0x40;
        }	
		#endif
    }
    return data;
}

/*************************************************************************************
 * @fun_name   static u32 GetA4Data(u8 index)
 * @brief      	LCDA4
 * @param[in] 	index
 * @param[out] 	data
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static u32 GetA4Data(u8 index)
{
    u32 data = 0;
	To_lcd_Float temp;

	if( index == GP30_APP_TOTAL_FLOW )//ȡۼ
	{
		data=Gp30CheckTestDataApp(GP30_APP_TOTAL_FLOW);
	}
	else if (index ==GP30_APP_INS_FLOW) //ȡ˲ʱ
	{
		data=Gp30CheckTestDataApp(GP30_APP_INS_FLOW_LCD);
	}
	else if(index==GP30_APP_DIFF)//TOFʱ
	{
	//	  data= Gp22TimeDiffer(4);
		data=Gp30CheckTestDataApp(GP30_APP_DIFF);
	}
	else if(index==GP30_APP_TOF)//ʱup˳ʱ
	{
		data= Gp30CheckTestDataApp(GP30_APP_TOF);//ʵʱupʱ
	}
	else if(index==GP30_APP_DOWN) //ʱdownʱ
	{
		data= Gp30CheckTestDataApp(GP30_APP_DOWN);//ʵʱdownʱ
	}
	else if(index==GP30_APP_TEMP)//¶ֵ
	{
		temp.gp22_float = TempCheckValueApp();
		return temp.gp22_u32;
	}   
	return data;
}

/*************************************************************************************
 * @fun_name   void LcdDisplayMenu(u8 num)
 * @brief      	LCDʾһ˵
 * @param[in] 	num :1-5
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdDisplayMenu(u8 num)
{
    //ʾЧA1 A2 A3 A4 
    LcdClearAll(); //
    if (num > 0 && num < 5)
    {
        LcdDisplayFun(LcdGetDisplayFun());
        LcdDisplayData(3, DIS_HG); //ʾ-
        LcdDisplayData(4, DIS_A); //ʾA
        LcdDisplayData(5, num); //ʾ
        LcdDisplayData(6, DIS_HG); //ʾ-
    }
    else
    {
        LcdDisplayData(3, DIS_E); //ʾE
        LcdDisplayData(4, DIS_E); //ʾE
        LcdDisplayData(5, DIS_HG); //ʾ-
        LcdDisplayData(6, DIS_A); //ʾA
    }
}

/*************************************************************************************
 * @fun_name   void LcdDisplayA1(u8 num)
 * @brief      	LCDʾ˵A1
 * @param[in] 	num:1ʼ
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdDisplayA1(u8 num)
{
    To_lcd_Float temp;
    LcdClearAll(); //
    switch (num)
    {
		case A1B1:	
		{
	//			//ȷ5λС
			LcdDisplayFun(A1_ACCUMULATE_FLOW); //ۼ(ʾֱΪ0.001m3)
			s_a1_index = GP30_APP_TOTAL_FLOW;
			s_a1_backup = GetA1Data(s_a1_index);
			temp.gp22_u32 =s_a1_backup;

			if (temp.gp22_float < A1_TOTAL_DISPLAY_4_D)//С10ʾ5λ
			{
				LcdDispayFLoat(temp.gp22_float / 100, 1); //ۼ(float(iEEE754),Ŵ100)
			}
			else  //ʾ3λС
			{
				LcdDispayFLoat(temp.gp22_float / 100, 3); //ۼ(float(iEEE754),Ŵ100)
			}
			break;
		}
		case A1B2:	
    {
			//ʾ
				LcdDisplayFun(A1_ACCUMULATE_FLOW_REVERSE); //ۼ(ʾֱΪ0.001m3)
        s_a1_index = GP30_APP_TOTAL_FLOW_REVERSE;
        s_a1_backup = GetA1Data(s_a1_index);
        temp.gp22_u32 =s_a1_backup;				
				
			
        if (temp.gp22_float < A1_TOTAL_DISPLAY_2_D)
        {
            LcdDispayFLoat(-(temp.gp22_float / 100), 3); //ۼ(float(iEEE754),Ŵ100)
        }
        else if (temp.gp22_float < A1_TOTAL_DISPLAY_1_D)
        {
            LcdDispayFLoat(-(temp.gp22_float / 100), 4); //ۼfloat(iEEE754),Ŵ100)
        }
        else if (temp.gp22_float < A1_TOTAL_DISPLAY_0_D)
        {
            LcdDispayFLoat(-(temp.gp22_float / 100), 5); //ۼ(float(iEEE754),Ŵ100)
        }
				else  //ݹ󣬲ʾС㡣
				{
					LcdDispayFLoat(-(temp.gp22_float / 100), 6); //ۼ(float(iEEE754),Ŵ100)
				}
        break;
		}
    case A1B3:
    {
        LcdDisplayFun(A1_TIME_FLOW); //˲ʱ(ʾֱΪ0.00001m3/h)
        s_a1_index = GP30_APP_INS_FLOW;
        s_a1_backup = GetA1Data(s_a1_index);
        LcdDispayFLoat(s_a1_backup / (float)65536.00/1000, 1); //0.00001m3/h)
        break;
    }
    case A1B4:
    {
        LcdDisplayFun(A1_ACCUMULATE_TIME); //ۼʱ(ֱΪ1h)
        s_a1_index = 0x55;
        s_a1_backup = GetA1Data(s_a1_index);
        if(s_a1_backup < 10)
        {
            LcdDisplayData(7, 0);
            LcdDisplayData(6, 0);
            LcdDispayU32Data(s_a1_backup, 0);
        }
        else if(s_a1_backup < 100)
        {
            LcdDisplayData(6, 0);
            LcdDispayU32Data(s_a1_backup, 0);
        }
        else
        {
            LcdDispayU32Data(s_a1_backup, 0);
        }
        break;
    }
	case A1B5://ȫ
    {
		LcdDisplayAll();
		break;
    }

    default:
    {
        LcdDisplayData(2, DIS_E); //ʾE
        LcdDisplayData(3, DIS_E); //ʾE
        LcdDisplayData(4, DIS_A); //ʾA
        LcdDisplayData(5, DIS_1); //ʾ1
    }
    }
}

/*************************************************************************************
 * @fun_name   void LcdDisplayA2(u8 num)
 * @brief      	LCDʾ˵A2
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
//extern void setuploadflag(void);
//u8 uploadcnt=0;
static void LcdDisplayA2(u8 num)
{
    LcdClearAll(); //
    LcdDisplayFun(LcdGetDisplayFun());//ַ̻
    switch (num)
    {
    case A2B1:
    {
        //ʾǰ
        s_a2_index = 0x11;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDisplayData(1, (s_a2_backup >> 20)&0x0F);
        LcdDisplayData(2, (s_a2_backup >> 16)&0x0F);
        LcdDisplayData(3, DIS_HG); //ʾ-
        LcdDisplayData(4, (s_a2_backup >> 12)&0x0F);
        LcdDisplayData(5, (s_a2_backup >> 8)&0x0F);
        LcdDisplayData(6, DIS_HG); //ʾ-
        LcdDisplayData(7, (s_a2_backup >> 4)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 0)&0x0F);
	//	uploadcnt=0;
        break;
    }
    case A2B2:
    {
        //ʾǰʱ
        s_a2_index = 0x22;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDisplayData(1, (s_a2_backup >> 20)&0x0F);
        LcdDisplayData(2, (s_a2_backup >> 16)&0x0F);
        LcdDisplayData(3, DIS_HG); //ʾ-
        LcdDisplayData(4, (s_a2_backup >> 12)&0x0F);
        LcdDisplayData(5, (s_a2_backup >> 8)&0x0F);
        LcdDisplayData(6, DIS_HG); //ʾ-
        LcdDisplayData(7, (s_a2_backup >> 4)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 0)&0x0F);
	/*	uploadcnt++;
		if(uploadcnt==10)
		{
			setuploadflag();
		}*/
        break;
    }
    case A2B3:
    {
        //ʾھ1-   20
        LcdDisplayData(1, 1);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 1;
        s_a2_backup = GetA2Data(s_a2_index); 
        LcdDispayU32Data((s_a2_backup / 16 * 10 + s_a2_backup % 16), 0);
        break;
    }
    case A2B4:
    {
        //ʾ汾2-   b0.1
        LcdDisplayData(1, 2);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 2;
        s_a2_backup = GetA2Data(s_a2_index); //0xB0, 0x10, 0x00, 0x00
        LcdDisplayFun(FUN_P3);
        LcdDisplayData(5, (s_a2_backup >> 28)&0x0F);
        LcdDisplayData(6, (s_a2_backup >> 24)&0x0F);
        LcdDisplayData(7, (s_a2_backup >> 20)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 16)&0x0F);
        break;
    }
    case A2B5:
    {
        //ʾ(ͨѶַһֽڣ
        LcdDisplayData(1, 3);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 3;
        s_a2_backup = GetA2Data(s_a2_index);
		LcdDisplayData(3, (s_a2_backup >> 20)&0x0F);
        LcdDisplayData(4, (s_a2_backup >> 16)&0x0F);
		LcdDisplayData(5, (s_a2_backup >> 12)&0x0F);
        LcdDisplayData(6, (s_a2_backup >> 8)&0x0F);
        LcdDisplayData(7, (s_a2_backup >> 4)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 0)&0x0F);
        break;
    }
    case A2B6:
    {
        //ַֽ
        s_a2_index = 4;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDisplayData(1, (s_a2_backup >> 28)&0x0F);
        LcdDisplayData(2, (s_a2_backup >> 24)&0x0F);
        LcdDisplayData(3, (s_a2_backup >> 20)&0x0F);
        LcdDisplayData(4, (s_a2_backup >> 16)&0x0F);
        LcdDisplayData(5, (s_a2_backup >> 12)&0x0F);
        LcdDisplayData(6, (s_a2_backup >> 8)&0x0F);
        LcdDisplayData(7, (s_a2_backup >> 4)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 0)&0x0F);
        break;
    }
    case A2B7:
    {
        //ʾСϵ
        LcdDisplayData(1, 4);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 5;
        s_a2_backup = GetA2Data(s_a2_index); //0x00010000;
        LcdDispayFLoat(s_a2_backup / 65536.00, 3);
        break;
    }
    case A2B8:
    {
        //ʾ1ϵ
        LcdDisplayData(1, 5);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 6;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDispayFLoat(s_a2_backup / 65536.00, 3);
        break;
    }
    case A2B9:
    {
        //ʾ2ϵ
        LcdDisplayData(1, 6);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 7;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDispayFLoat(s_a2_backup / 65536.00, 3);
        break;
    }
    case A2B10:
    {
        //ʾ3ϵ
        LcdDisplayData(1, 7);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 8;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDispayFLoat(s_a2_backup / 65536.00, 3);
        break;
    }
    case A2B11:
    {
        //ʾϵ
        LcdDisplayData(1, 8);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 9;
        s_a2_backup = GetA2Data(s_a2_index);
        LcdDispayFLoat(s_a2_backup / 65536.00, 3);
        break;
    }
	case A2B12:
    {
        //ʾboot汾
        LcdDisplayData(1, 9);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 10;
        s_a2_backup = GetA2Data(s_a2_index); 
        LcdDisplayFun(FUN_P3);
        LcdDisplayData(5, (s_a2_backup >> 12)&0x0F);
        LcdDisplayData(6, (s_a2_backup >> 8)&0x0F);
        LcdDisplayData(7, (s_a2_backup >> 4)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 0)&0x0F);
        break;
    }
	case A2B13:
    {
        //ʾӲ汾- 00.14
        LcdDisplayData(1, 10);
        LcdDisplayData(2, DIS_HG);
        s_a2_index = 2;
        s_a2_backup = GetA2Data(s_a2_index); 
        LcdDisplayFun(FUN_P3);
        LcdDisplayData(5, (s_a2_backup >> 12)&0x0F);
        LcdDisplayData(6, (s_a2_backup >> 8)&0x0F);
        LcdDisplayData(7, (s_a2_backup >> 4)&0x0F);
        LcdDisplayData(8, (s_a2_backup >> 0)&0x0F);
        break;
    }
	case A2B14://NB״̬Ϣ
    {
        s_a2_index = 11;
        s_a2_backup = GetA2Data(s_a2_index); 
		UNION_4U8TOU32 tempdata;
		tempdata.datas = s_a2_backup;
		if((s_a2_backup&0xFF)==1)//ʼ
		{
			LcdDisplayData(0, 11);
			LcdDisplayData(1, DIS_HG);
			//
			LcdDisplayData(2, tempdata.data_buf[0]);
			LcdDisplayData(3, DIS_HG);
			//
			LcdDisplayData(4, tempdata.data_buf[1]/10);
			LcdDisplayData(5, tempdata.data_buf[1]%10);
			//cereg
			LcdDisplayData(6, DIS_HG);
			LcdDisplayData(7, tempdata.data_buf[2]);
			//cgatt
			LcdDisplayData(8, DIS_HG);
			LcdDisplayData(9, tempdata.data_buf[3]);
		}
		if((s_a2_backup&0xFF)==2)//
		{
			LcdDisplayData(0, 11);
			LcdDisplayData(1, DIS_HG);

			//
			LcdDisplayData(2, tempdata.data_buf[0]);
			LcdDisplayData(3, DIS_HG);
			//
			LcdDisplayData(4, tempdata.data_buf[1]/10);
			LcdDisplayData(5, tempdata.data_buf[1]%10);
			//cereg
			LcdDisplayData(6, DIS_HG);
			LcdDisplayData(7, tempdata.data_buf[2]);
			//cgatt
			LcdDisplayData(8, DIS_HG);
			LcdDisplayData(9, tempdata.data_buf[3]);
		}
		if((s_a2_backup&0xFF)==3)//źֵ
		{
			//RSRP
			LcdDisplayData(0, DIS_HG);
			LcdDisplayData(1, (tempdata.data_buf[1]/100));
			LcdDisplayData(2, (tempdata.data_buf[1]/10)%10);
			LcdDisplayData(3, (tempdata.data_buf[1]%10));
			//SNR
			if(tempdata.data_buf[2]&0x80)//
			{
				LcdDisplayData(4, DIS_HG);
				LcdDisplayData(5, (tempdata.data_buf[2]&0x7F)/10);
				LcdDisplayData(6, (tempdata.data_buf[2]&0x7F)%10);
			}
			else
			{
				LcdDisplayData(4, DIS_BLANK);
				LcdDisplayData(5, (tempdata.data_buf[2]/10));
				LcdDisplayData(6, tempdata.data_buf[2]%10);
			}
			//CSQ
			LcdDisplayData(7, DIS_BLANK);
			LcdDisplayData(8, (tempdata.data_buf[3]/10));
			LcdDisplayData(9, (tempdata.data_buf[3]%10));
		}
		if((s_a2_backup&0xFF)==4)//״̬
		{
			LcdDisplayData(0, 11);
			LcdDisplayData(1, DIS_HG);
			//״̬
			LcdDisplayData(2, (tempdata.data_buf[1]));
			//ոλ
			LcdDisplayData(3, DIS_HG);
			LcdDisplayData(4, tempdata.data_buf[2]/10);
			LcdDisplayData(5, tempdata.data_buf[2]%10);
		}
		
        break;
    }

    default:
    {
        break;
    }
    }
}
/*************************************************************************************
 * @fun_name   void LcdDisplayA3(u8 num)
 * @brief      	LCDʾ˵A3
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdDisplayA3(u8 num)//ѯ쳣MSG,Ӧλ1
{
    LcdClearAll(); //
    LcdDisplayFun(LcdGetDisplayFun());//ַ̻
    switch (num)
    {
    case A3B1://1-0000
    {
        LcdDisplayData(1, 1);
        LcdDisplayData(2, DIS_HG);
        s_a3_index = 0x01;
        s_a3_backup = GetA3Data(s_a3_index);
        if ((s_a3_backup>>2) & 0x01)//ʾ1-1000װ
        {
            LcdDisplayData(5, 1);
        }
        else
        {
            LcdDisplayData(5, 0);
        }
        if ((s_a3_backup>>3) & 0x01)//ʾ1-0100ܵˮ
        {
            LcdDisplayData(6, 1);
        }
        else
        {
            LcdDisplayData(6, 0);
        }
        if ((s_a3_backup) & 0x01)// ʾ1-0010ϻ
        {
            LcdDisplayData(7, 1);
        }
        else
        {
            LcdDisplayData(7, 0);
        }
        if((s_a3_backup>>1) & 0x01)//ʾ1-0001ˮ³
        {
            LcdDisplayData(8, 1);
        }
        else
        {
            LcdDisplayData(8, 0);
        }        
        break;
    }
    case A3B2://2-  0000
    {  
        LcdDisplayData(1, 2);
        LcdDisplayData(2, DIS_HG);
        s_a3_index = 0x02; 
        s_a3_backup = GetA3Data(s_a3_index);
        if ((s_a3_backup>>4) & 0x01)//ʾ2-1000 GP30쳣
        {
            LcdDisplayData(5, 1);
        }
        else
        {
            LcdDisplayData(5, 0);
        }
        if((s_a3_backup>>5) & 0x01)//ʾ2-0100 ¶ȴ쳣
        {
            LcdDisplayData(6, 1);
        }
        else
        {
            LcdDisplayData(6, 0);
        }
        if((s_a3_backup>>6) & 0x01)//Ź
        {
            LcdDisplayData(7, 1);
        }
        else
        {
            LcdDisplayData(7, 0);
        }
        if ((s_a3_backup>>7) & 0x01)//ʾ2-0001 ϱ쳣
        {
            LcdDisplayData(8, 1);
        }
        else
        {
            LcdDisplayData(8, 0);
        }
        break;
    }
    default:
    {
		break;
    }
    }
}

/*************************************************************************************
 * @fun_name   void LcdDisplayA4(u8 num)
 * @brief      	LCDʾ˵A4
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
static void LcdDisplayA4(u8 num)
{
    To_lcd_Float temp;
    float temp1;
    LcdClearAll(); //
    switch (num)
    {
		case A4B1:	
		{
			//ȷ5λС
			if(Sys_data_object.P3.LCD_NoTestFlag == 0x55) 
			{
				LcdDisplayFun(A4_ACCUMULATE_FLOW_NOTEST); //ۼ(춨ʱʾֱΪ0.00001m3,ʾλΪL,0.01L)
			}
			else
			{
				LcdDisplayFun(A4_ACCUMULATE_FLOW); //ۼ(춨ʱʾֱΪ0.00001m3,ʾλΪL,0.01L)
			}
			s_a4_index = GP30_APP_TOTAL_FLOW;
			s_a4_backup = GetA4Data(s_a4_index);
			temp.gp22_u32 =s_a4_backup;		
			LcdDispayFLoat(temp.gp22_float / 100000, 1);  //ۼ(float(iEEE754),Ŵ100000)
			break;
		}
		case A4B2:
		{
			//ȷ5λС
			if(Sys_data_object.P3.LCD_NoTestFlag == 0x55) 
			{
				LcdDisplayFun(A4_TIME_FLOW_NOTEST); // ˲ʱ(춨ʱʾֱΪ0.0001m3/h)
			}
			else
			{
				LcdDisplayFun(A4_TIME_FLOW); // ˲ʱ(춨ʱʾֱΪ0.0001m3/h)
			}
			s_a4_index = GP30_APP_INS_FLOW;
			s_a4_backup = GetA4Data(s_a4_index);
			LcdDispayFLoat(s_a4_backup/ 65536.00/1000, 1);//
			break;
		}
		case A4B3:
		{
			if(Sys_data_object.P3.LCD_NoTestFlag == 0x55) 
			{
				LcdDisplayFun(A4_TOF_TIME_NOTEST); // TOFʱֱΪ1h)
			}
			else
			{
				LcdDisplayFun(A4_TOF_TIME); // TOFʱֱΪ1h)
			}
			s_a4_index = GP30_APP_DIFF;
			s_a4_backup = GetA4Data(s_a4_index); 
			if (s_a4_backup >= 0x80000000)
			{
				s_a4_backup = s_a4_backup & 0x7FFFFFFF;
				temp1 = (float)((s_a4_backup) / 65536.0* (-25.0));//
			}
			else
			{    
				temp1 =(float)((s_a4_backup) / 65536.0*25.0); //
			}
				LcdDispayFLoat(temp1/100, 0);//ps
			break;
		}
		case A4B4:
		{
			if(Sys_data_object.P3.LCD_NoTestFlag == 0x55) 
			{
				LcdDisplayFun(A4_SINGLE_TIME_NOTEST); // ʱup(ֱΪ1h)
			}
			else
			{
				LcdDisplayFun(A4_SINGLE_TIME); // ʱup(ֱΪ1h)
			}
			LcdDisplayData(1, 1);
			LcdDisplayData(2, DIS_HG);
			s_a4_index = GP30_APP_TOF;
			s_a4_backup = GetA4Data(s_a4_index);
			temp1 =(float)(s_a4_backup / 65536.0*25.0);//
			LcdDispayFLoat(temp1/10000, 0); //λΪns
			break;
		}
		case A4B5:
		{
			if(Sys_data_object.P3.LCD_NoTestFlag == 0x55) 
			{
				LcdDisplayFun(A4_SINGLE_TIME_NOTEST); // ʱdown(ֱΪ1h)
			}
			else
			{
				LcdDisplayFun(A4_SINGLE_TIME); // ʱdown(ֱΪ1h)
			}
		   LcdDisplayData(1, 2);
		   LcdDisplayData(2, DIS_HG);
		  
		   s_a4_index = GP30_APP_DOWN;
		   s_a4_backup = GetA4Data(s_a4_index);
		   temp1 = (float) ((s_a4_backup) / 65536.0*25.0 );//
		   LcdDispayFLoat(temp1/10000, 0); //λΪns
		   break;
		}
		case A4B6:
		{
			if(Sys_data_object.P3.LCD_NoTestFlag == 0x55) 
			{
				LcdDisplayFun(A4_Tem_NOTEST); // ¶ȷֱΪ0.1϶
			}
			else
			{
				LcdDisplayFun(A4_Tem); // ¶ȷֱΪ0.1϶
			}
			#if WENDU_FANSUAN_OPEN
			LcdDisplayData(1, DIS_F);//ʾF----ֻзʾ	
			#endif
			s_a4_index = GP30_APP_TEMP;
			s_a4_backup = GetA4Data(s_a4_index);
			temp.gp22_u32 = s_a4_backup;
			LcdDispayFLoat(temp.gp22_float, 3); 
			break;
		}   
		default:
		{
			LcdDisplayData(3, DIS_E); //ʾE
			LcdDisplayData(4, DIS_E); //ʾE
			LcdDisplayData(5, DIS_A); //ʾA
			LcdDisplayData(6, DIS_4); //ʾ4
		}
    }
}
/*************************************************************************************
 * @fun_name   void LcdInitApp()
 * @brief      	LCDӦòʼ
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
void LcdInitApp()
{
    //״̬״̬
    s_lcd_status_state = 0; //״ָ̬ʾ״̬״̬
//    s_lcd_rf_state = 0; //״ָ̬ʾ״̬״̬
    s_lcd_time_state = 0; //ʱ״̬״̬
//    s_lcd_ram_state = 0; //RAM״̬״̬
    s_lcd_key_state = 0; //״̬״̬
//    s_lcd_init_state = 0; //ʼ״̬״̬
//    s_lcd_characters_state=1;//ʼַ̻״̬
//    s_lcd_valve_stat = 0;
//	  s_lcd_first_power_state = 0;
    //˵
	if(Gp30GetTestRamFlag() == GP30_COPY_RESET_TEST_FLAG)
	{
		s_fst_num = A4;
		s_sec_num = A4B1;
	}
	else
	{
		s_fst_num = A1; //һ˵Ĳ˵
		s_sec_num = A1B1; //˵Ĳ˵
	}

    //б
    s_vol_app_state = NORMAL_POWER; //¼ϴεصѹ״̬
//    s_valve_state = 0x40; //¼ϴη״̬
    s_low_flow_alarm_app_state = 0; //¼ϴγź״̬
    s_alarm_app_state = 0; //¼ϴα״̬
    s_failure_app_state = 0; //¼ϴι״̬
	s_valve_app_state = 0;
    s_active_RF_app_state =1; //¼ϴͨ״̬ 1Ϊ
    s_a1_backup = 0; //¼Ǽ춨״̬µǰLCDʾ
    s_a4_backup = 0; //¼춨״̬µǰLCDʾ
}

/*************************************************************************************
 * @fun_name   u8 LcdCheckStateApp()
 * @brief      	LCDؼ춨״̬
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
u8 LcdCheckStateApp()
{
    if (s_fst_num == A4)
    {
        return 01;
    }
    else
    {
        return 10;
    }
}

/*************************************************************************************
 * @fun_name   u8 LcdIfSleepApp()
 * @brief      	LCDӦòǷ
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
u8 LcdIfSleepApp()
{
    if (s_fst_num == A2 && s_sec_num == A2B2)//ϵͳʱ治
    {
        return FALSE;
    }
    else if (s_fst_num == A4 && s_sec_num != AB0)//춨״̬
    {
        return FALSE;
    }
    else if (s_lcd_status_state != 0)//״̬ʾ
    {
        return FALSE;
    }
    else
    {
        return TRUE;
    }
}
/*************************************************************************************
 * @fun_name   u16 LcdCheckMeumApp()
 * @brief      	LCDز˵
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
u16 LcdCheckMeumApp()
{
    return s_sec_num | ((u16) s_fst_num << 8);
}


/*******************************************************************************
 * @fun_name:	lcd_alarmCheckMsgSys()
 * @brief   :  
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
u8 lcd_alarmCheckWarningMsg(void)
{    
		if ((s_lcd_check_gp30_app_msg & 0x40)||  //
			(s_lcd_check_gp30_app_msg & 0x02)||  //ˮ³¶ȵȼΧ
			(s_lcd_check_gp30_app_msg & 0x04)||  //ת
			(s_lcd_check_gp30_app_msg & 0x08)    //ˮ 
		) //Ա
	 {
	    return 1;
	 }
     else
     {
	 	return 0; 
	 }
}
/*******************************************************************************
 * @fun_name:	lcd_alarmCheckMsgSys()
 * @brief   :  ϼ
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
u8 lcd_alarmCheckFaultMsg(void)//T2ϣԹ
{    
    if ((NB_SS_Control_GetPara(NB_UploadFailTimes)|| //Ҫ˵ͨŹ
        (s_lcd_check_gp30_app_msg & 0x10)) || //GPXX쳣
        (s_lcd_check_gp30_app_msg & 0x80)  || //GPXXͨŹ
        (s_lcd_check_gp30_app_msg & 0x01)     //
			 #if defined(VALVE)//Źϱ־
		    ||(Sys_data_object.P1.ies_valve_paras.valve_err)
				#endif
		    ) 
        {
            return 1;
        }
        else
        {
            return 0; 
        }	 
}
/*******************************************************************************
 * @fun_name:	LcdDispalyMetStatus()
 * @brief   :   LCDʵʱʾƱϵ״̬(ַ)
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
void LcdDispalyMetStatus()
{
	s_lcd_check_gp30_app_msg =Gp30CheckErrDataApp();
    switch (s_lcd_status_state)
    {
        case 0:
        {
			if (PowerCheckStatusSys ()!= s_vol_app_state)//T5ѹ
			{
				s_vol_app_state = PowerCheckStatusSys ();
				s_lcd_status_state = 1;
			}
			if ((s_lcd_check_gp30_app_msg & 0x20) != s_low_flow_alarm_app_state) //T4bit5
			{
				s_low_flow_alarm_app_state = s_lcd_check_gp30_app_msg & 0x20;
				s_lcd_status_state = 1;
			}
			if (lcd_alarmCheckWarningMsg() != s_alarm_app_state)//T1
			{
				s_alarm_app_state = lcd_alarmCheckWarningMsg();
				s_lcd_status_state = 1;
			}
			if (lcd_alarmCheckFaultMsg() != s_failure_app_state )//T2
			{
				s_failure_app_state =lcd_alarmCheckFaultMsg();
				s_lcd_status_state = 1;
			}
			#if defined(VALVE)
				if(ValveGetStateApp() != s_valve_app_state)	/*ӷʾ*/
				{
					s_valve_app_state = ValveGetStateApp();
					s_lcd_status_state = 1;
				}	
			#endif			
            break;
        }
        case 1:
        {
            if (PowerCheckStatusSys () == LOW_POWER)//ѹ
			{
			    LcdDisplayVol(1);
			}
            else
            {
                LcdDisplayVol(0);
            }
            if (s_low_flow_alarm_app_state == 0x20)//
            {
               LcdDisplayLowFlowAlarm(1);
            }
            else
            {
             LcdDisplayLowFlowAlarm(0);
            }
            if (s_alarm_app_state == 1)//
            {
                LcdDisplayAlarm(1);
            }
            else
            {
                LcdDisplayAlarm(0);
            }
            if (s_failure_app_state == 1)//
            {
                LcdDisplayFailure(1);
            }
            else
            {
                LcdDisplayFailure(0);
            }
            if(s_active_RF_app_state==0)//ͨ 0 æ
            {
             LcdDisplayActiveGPRS(1);
            }
            else
            {
             LcdDisplayActiveGPRS(0);
            }
			if(VALVE_STATE_CLOSE == s_valve_app_state ||VALVE_STATE_CLOSE_EMERGENCY == s_valve_app_state || VALVE_STATE_CLOSE_LOCK == s_valve_app_state)//Źر
			{
				LcdDisplayValve(1);
			}
			else
			{
				LcdDisplayValve(0);
			}
            s_lcd_status_state = 0;
            break;
        }
		default:
		{
		    s_lcd_status_state = 0;
			break;
		}
    }
}

/*******************************************************************************
 * @fun_name:	LcdDisplayTimeUpChange()
 * @brief   :   LCDʱ״̬
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
void LcdDisplayTimeUpChange()
{
    switch (s_lcd_time_state)
    {
		case 0://Ļʱ
		{
			if ((s_fst_num == A1 && s_sec_num != A1B1 ) || s_fst_num == A2 || s_fst_num == A3)
			{
				RtccSetTimer(RTCC_TIMER_LCD_NUM, 60); //60s
				s_lcd_time_state = 1;
			}
			else if (s_fst_num == A4)
			{
				RtccSetTimer(RTCC_TIMER_LCD_NUM, LCD_A4_TIME); //춨״̬ް(3h)A1B1
				s_lcd_time_state = 1;
			}
			break;
		}
		case 1:
		{
			if (!RtccCheckTimer(RTCC_TIMER_LCD_NUM))//ʱʱ䵽,ָĬϽ
			{
				s_fst_num = A1;
				s_sec_num = A1B1;
				LcdDisplayA1(s_sec_num);
				s_lcd_time_state = 0;
			}
			break;
		}
		default:
		{
			s_lcd_time_state = 0;
			break;
		}
   }
}
/*******************************************************************************
 * @fun_name:	LcdDisplayKey()
 * @brief   :   LCD״̬
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
void LcdDisplayKey()
{
	if(s_lcd_key_state == 0)//ʱл
	{
		s_lcd_key_state = 1;
		if(Gp30GetTestRamFlag() == GP30_COPY_RESET_TEST_FLAG)//жǷλǰڼ춨״̬
		{
			s_fst_num = A4;
			s_sec_num = A4B1;
			LcdDisplayA4(s_sec_num);
		}
		else
		{
			s_fst_num = A1;
			s_sec_num = A1B1;
			LcdDisplayA1(s_sec_num);
		}
	}
	else if(KeyCheckLcdMsgApp(MENU_ONE))//һ˵л
	{
		s_lcd_time_state = 0;
		//һ˵
		KeyClearLcdMsgApp(MENU_ONE);
		if ((s_fst_num == A4)&&(s_sec_num == A4B3))//춨״̬˲ʱ˼춨
		{
			s_fst_num = A1;
			s_sec_num = AB0;
			LcdClearAll(); //
			LcdDisplayMenu(s_fst_num);
		}
		else
		{
			if(s_fst_num != A4)//Ǽ춨л
			{
				s_fst_num %= AU;
				s_fst_num++;
				s_sec_num = AB0;
				LcdClearAll(); //
				LcdDisplayMenu(s_fst_num);
			}
		}
	}
	else if(KeyCheckLcdMsgApp(MENU_TWO))//˵л
	{
		s_lcd_time_state = 0;
		//ж˵
		LcdClearAll(); //
		KeyClearLcdMsgApp(MENU_TWO);
		if (s_fst_num == A1)
		{
			s_sec_num %= B1U;
			s_sec_num++;
			LcdDisplayA1(s_sec_num);
		}
		if (s_fst_num == A2)
		{
			s_sec_num %= B2U;
			s_sec_num++;
			LcdDisplayA2(s_sec_num);
		}
		if (s_fst_num == A3)
		{
			s_sec_num %= B3U;
			s_sec_num++;
			LcdDisplayA3(s_sec_num);
		}
		if (s_fst_num == A4)
		{
			s_sec_num %= B4U;
			s_sec_num++;
			LcdDisplayA4(s_sec_num);
		}
	}
	else if(KeyCheckLcdMsgApp(MENU_DEFAULT))//쳣лĬϲ˵
	{
		s_lcd_time_state = 0;
		KeyClearLcdMsgApp(MENU_DEFAULT);
		if (s_fst_num != A4 )
		{
			LcdClearAll(); //
			//Ĭϲ˵
			s_fst_num = A1;
			s_sec_num = A1B1;
			LcdDisplayA1(s_sec_num);
		}
	}
	else if(KeyCheckLcdMsgApp(MENU_TEST))//춨
	{
		s_lcd_time_state = 0;
		LcdClearAll(); //
		//м춨˵
		KeyClearLcdMsgApp(MENU_TEST);
		s_fst_num = A4;
		s_sec_num = AB0;
		LcdDisplayMenu(s_fst_num);
		LcdDisplayFun(LcdGetDisplayFun() | FUN_TEST );
	}
	else if (FrameCheckMsgApp(LcdDisplayAllMsg))//ȫ
	{   
		s_lcd_time_state = 0;
		LcdClearAll(); //
		FrameClearMsgApp(LcdDisplayAllMsg);
		s_fst_num = A1;
		s_sec_num = A1B5;
		LcdDisplayA1(s_sec_num);
	}
	else if (FrameCheckMsgApp(SetVerificationMsg))//춨
	{
		s_lcd_time_state = 0;
		LcdClearAll(); //
		FrameClearMsgApp(SetVerificationMsg);
		s_fst_num = A4;
		s_sec_num = A4B1;
		LcdDisplayA4(s_sec_num);
	}
	else if (FrameCheckMsgApp(OutVerificationMsg))//˼춨
	{   
		s_lcd_time_state = 0;
		LcdClearAll(); //
		FrameClearMsgApp(OutVerificationMsg);
		s_fst_num = A1;
		s_sec_num = A1B1;
		LcdDisplayA1(s_sec_num);
	}
}
/*************************************************************************************
 * @fun_name   void LcdMachineApp(void)
 * @brief      	LCDӦò״̬
 * @param[in] 	None
 * @param[out] 	None
 * @retval     	None
 * @other     	None
 *************************************************************************************/
void LcdMachineApp(void)
{
	if(!RtccCheckTimer(RTCC_TIMER_LCD_METSTATUES))
	{
		RtccSetTimer(RTCC_TIMER_LCD_METSTATUES,LCD_UPDATE_TIME); //ʱ1
		LcdDispalyMetStatus();
		LcdDisplayTimeUpChange();
		LcdUpdateData();  
		#if MODULE_BLE_USED  
			if((BleConnectIfIdle() == TASK_IDLE)&&(BleIfSleep()==TASK_IDLE))
			{
				LcdDisplayActiveGPRS(0);//߷
			}
			else
			{
				LcdDisplayActiveGPRS(1);//ʾ߷
			}
		#else
			if(FixedTimeNbIoTUploadIfIdle() == TASK_IDLE) 
			{
				LcdDisplayActiveGPRS(0);//߷
			}
			else
			{
				LcdDisplayActiveGPRS(1);//ʾ߷
			}
		#endif
	} 
	LcdDisplayKey(); 
 }
/*void setLcdA2B14(void)
{
	s_lcd_time_state = 0;
	LcdClearAll(); //
	s_fst_num = A2;
	s_sec_num = A2B14;
	LcdDisplayA2(s_sec_num);
}*/
 

 
 
