
#ifndef __UWater_LCD_APP_H
#define __UWater_LCD_APP_H
#include "sys_config.h"
#include "type.h"

#ifdef __cplusplus
extern "C" {
#endif

#define A1                        1
#define A2                        2
#define A3                        3
#define A4                        4
#define A5                        5
#define AB0                       0
#define AU                        3

#define A1B1                      1
#define A1B2                      2
#define A1B3                      3
#define A1B4                      4
#define A1B5                      5
#define B1U                       5

#define A2B1                      1
#define A2B2                      2
#define A2B3                      3
#define A2B4                      4
#define A2B5                      5
#define A2B6                      6
#define A2B7                      7
#define A2B8                      8
#define A2B9                      9
#define A2B10                     10
#define A2B11                     11
#define A2B12                     12
#define A2B13                     13
#define A2B14                     14
#define B2U                       14

#define A3B1                      1
#define A3B2                      2
#define B3U                       2

#define A4B1                      1
#define A4B2                      2
#define A4B3                      3
#define A4B4                      4
#define A4B5                      5
#define A4B6                      6
#define B4U                       6

#define LCD_RF_TIME               10           //λ100ms
#define LCD_UPDATE_TIME           1          //λ1s

//#define LCD_RAM_TIME              10           //λ100ms
//#define LCD_A1_TIME               10          //λs
//#define LCD_A23_TIME              60           //λs
#define LCD_A4_TIME               10800 //3*60*60        //λs
//#define LCD_VAL_TIME              1       //λs

//ַ̻涨

//A1˵
#define A1_ACCUMULATE_FLOW              ( FUN_M3 )//ۼm3)(ʾֱΪ0.001M3/H)
#define A1_ACCUMULATE_FLOW_REVERSE      ( FUN_REVERSE | FUN_M3 )
#define A1_TIME_FLOW                    ( FUN_M3 | FUN_FH  | FUN_HOUR )//˲ʱ(ʾֱΪ0.001M3/H)
#define A1_ACCUMULATE_TIME              ( FUN_HOUR ) //ۼʱ

//#define A1_UNITP                         ( FUN_YUAN )//
//#define A1_REMAIN                       (FUN_SY | FUN_YUAN)      //ʣ
//#define A1_PURCJASE                      (FUN_GR| FUN_YUAN)    //
//#define A1_W_COMUNICATION                (FUN_GPRSING)   //Ƶ


//A2˵
//#define A1_ACCUMULATE_TIME             ( FUN_M3)//ۼm3

//A4˵ 4ͬĹַ̻(춨ģʽ)
#define A4_ACCUMULATE_FLOW              (FUN_TEST | FUN_M3)//ۼ(L)(춨ʱʾֱΪ0.0001M3/HʾλΪL0.01L)
#define A4_TIME_FLOW                    (FUN_TEST | FUN_FH | FUN_M3 | FUN_HOUR)//˲ʱ(m3/h)(ֱΪ0.0001M3/H)
#define A4_TOF_TIME                     (FUN_TEST | FUN_HOUR )//TOFʱֱΪ1h
#define A4_SINGLE_TIME                  (FUN_TEST | FUN_HOUR )//ʱup(ֱΪ1h)
//#define A4_Pressure                     (FUN_TEST | FUN_PASCAL)//ѹ
#define A4_Tem                          (FUN_TEST | FUN_TEMPERATURE)//¶

#define A4_ACCUMULATE_FLOW_NOTEST              (FUN_M3)//ۼ(L)(춨ʱʾֱΪ0.0001M3/HʾλΪL0.01L)
#define A4_TIME_FLOW_NOTEST                    (FUN_FH | FUN_M3 | FUN_HOUR)//˲ʱ(m3/h)(ֱΪ0.0001M3/H)
#define A4_TOF_TIME_NOTEST                     (FUN_HOUR )//TOFʱֱΪ1h
#define A4_SINGLE_TIME_NOTEST                  (FUN_HOUR )//ʱup(ֱΪ1h)
//#define A4_Pressure_NOTEST                   (FUN_PASCAL)//ѹ
#define A4_Tem_NOTEST                          (FUN_TEMPERATURE)//¶
//춨״̬ ״̬
/***************************************************/
//#define ACCUMULATE_FLOW   0x00
//#define TIME_FLOW         0x01
//#define TOF_TIME          0x02
//#define SINGLE_TIME       0x03
//#define LCD_Pressure      0x04
//#define LCD_Tem           0x05
/******************************************************/


//A1˵0ͬĹַ̻
#define A1_TOTAL_DISPLAY_4_D 1000//10
#define A1_TOTAL_DISPLAY_3_D 100000
#define A1_TOTAL_DISPLAY_2_D 1000000
#define A1_TOTAL_DISPLAY_1_D 10000000
#define A1_TOTAL_DISPLAY_0_D 100000000
//ӿڲѯ
/***************************************************/

//#define GP22_APP_INS_FLOW     1//˲ʱ
//#define GP22_APP_TOTAL_FLOW   2//ۼ
/******************************************************/

 typedef union            //ǿתΪ
{
    u32   gp22_u32;
    float gp22_float;
} To_lcd_Float;

//ӿں
extern u8 LcdIfSleepApp(void);
extern u8 LcdCheckStateApp(void);
extern u16 LcdCheckMeumApp(void);
extern void LcdMachineApp(void);
extern void LcdInitApp(void);


#ifdef __cplusplus
}
#endif


#endif /* __UWater_LCD_APP_H */



